Summary: A systems administration tool for networks
Name: cfengine
Version: 2.2.10
Release: 2
License: GPLv2+
Group: Applications/System
Source0: ftp://ftp.iu.hio.no/pub/cfengine/%{name}-%{version}.tar.gz
Source1: cfenvd.aix.init
Source2: cfexecd.aix.init
Source3: cfservd.aix.init
Patch0: cfengine-shellcommands-allclasses-svn_r629.patch
URL: http://www.cfengine.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: db4-devel >= 4.7.25-2, openssl-devel >= 0.9.8, bison, flex, m4
BuildRequires: patch, pcre-devel >= 7.9
Requires: db4 >= 4.7.25-2, openssl >= 0.9.8, pcre >= 7.9
Requires: /sbin/install-info, info

%description
Cfengine, or the configuration engine is an agent/software robot and a
very high level language for building expert systems to administrate
and configure large computer networks. Cfengine uses the idea of
classes and a primitive form of intelligence to define and automate
the configuration and maintenance of system state, for small to huge
configurations. Cfengine is designed to be a part of a computer immune
system.


%package doc
Summary: Documentation for cfengine
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description doc
This package contains the documentation for cfengine.


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch0 -p0 -b .shellcommands


%build
export CC="cc -qcpluscmt"

./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --with-openssl=%{_prefix} \
    --with-pcre=%{_prefix} \
    --enable-shared --disable-static

make %{?_smp_mflags}

# Some of the example files have execute bit set
chmod 644 inputs/*example
chmod 644 contrib/cfdoc


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

cd doc
make install-man DESTDIR=${RPM_BUILD_ROOT}
make install-info DESTDIR=${RPM_BUILD_ROOT}
cd ..

/usr/bin/strip ${RPM_BUILD_ROOT}%{_sbindir}/* || :

rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir
gzip --best ${RPM_BUILD_ROOT}%{_infodir}/*info*

# make directory tree for cfengine configs
mkdir -p ${RPM_BUILD_ROOT}/var/%{name}
for i in ppkeys inputs outputs ; do
    mkdir -m 0700 ${RPM_BUILD_ROOT}/var/%{name}/$i
done

# It's ugly, but thats the way Mark wants to have it. :(
# If we don't create this link, cfexecd will not be able to start
# (hardcoded) /var/sbin/cfagent in scheduled intervals. Other option 
# would be to patch cfengine to use %{_sbindir}/cfagent
mkdir -p ${RPM_BUILD_ROOT}/var/%{name}/bin
ln -sf %{_sbindir}/cfagent ${RPM_BUILD_ROOT}/var/%{name}/bin/

# All this stuff is pushed into doc/contrib directories
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name} 
rm -f ${RPM_BUILD_ROOT}%{_sbindir}/cfdoc

# Startup files for cfenvd, cfexecd and cfservd
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d
cp %{SOURCE1} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/cfenvd
cp %{SOURCE2} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/cfexecd
cp %{SOURCE3} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/cfservd
chmod 0755 ${RPM_BUILD_ROOT}/etc/rc.d/init.d/*

ln -sf '../init.d/cfenvd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kcfenvd
ln -sf '../init.d/cfenvd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Scfenvd
ln -sf '../init.d/cfenvd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kcfenvd
ln -sf '../init.d/cfenvd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Scfenvd

ln -sf '../init.d/cfexecd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kcfexecd
ln -sf '../init.d/cfexecd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Scfexecd
ln -sf '../init.d/cfexecd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kcfexecd
ln -sf '../init.d/cfexecd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Scfexecd

ln -sf '../init.d/cfservd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Kcfservd
ln -sf '../init.d/cfservd' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/Scfservd
ln -sf '../init.d/cfservd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Kcfservd
ln -sf '../init.d/cfservd' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/Scfservd


%post
# cfagent won't run nicely, unless your host has keys.
if [ ! -f /var/%{name}/ppkeys/localhost.priv ] ; then
    %{_sbindir}/cfkey >/dev/null || :
fi
/sbin/install-info --info-dir=%{_infodir} %{_infodir}/cfengine*.info* 2> /dev/null || :


%preun
if [ "$1" = "0" ] ; then
    /sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/cfengine*.info* 2> /dev/null || :
    /etc/rc.d/init.d/cfenvd  stop || :
    /etc/rc.d/init.d/cfexecd stop || :
    /etc/rc.d/init.d/cfservd stop || :
fi


%postun
if [ $1 -ge 1 ] ; then
    /etc/rc.d/init.d/cfenvd  restart || :
    /etc/rc.d/init.d/cfexecd restart || :
    /etc/rc.d/init.d/cfservd restart || :
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc AUTHORS ChangeLog COPYING README TODO
%{_sbindir}/*
%{_libdir}/libcfengine*
%{_mandir}/man8/*
%{_infodir}/*
/etc/rc.d/init.d/cfenvd
/etc/rc.d/rc2.d/Scfenvd
/etc/rc.d/rc3.d/Scfenvd
/etc/rc.d/rc2.d/Kcfenvd
/etc/rc.d/rc3.d/Kcfenvd
/etc/rc.d/init.d/cfexecd
/etc/rc.d/rc2.d/Scfexecd
/etc/rc.d/rc3.d/Scfexecd
/etc/rc.d/rc2.d/Kcfexecd
/etc/rc.d/rc3.d/Kcfexecd
/etc/rc.d/init.d/cfservd
/etc/rc.d/rc2.d/Scfservd
/etc/rc.d/rc3.d/Scfservd
/etc/rc.d/rc2.d/Kcfservd
/etc/rc.d/rc3.d/Kcfservd
/var/%{name}


%files doc
%defattr(-,root,system,-)
%doc contrib 
%doc inputs
%doc doc/*html
%doc doc/*pdf
%{_infodir}/%{name}*


%changelog
* Thu Nov 25 2010 Michael Perzl <michael@perzl.org> - 2.2.10-2
- fixed a typo in the %post scripts

* Thu Feb 18 2010 Michael Perzl <michael@perzl.org> - 2.2.10-1
- first version for AIX V5.1 and higher
